<script setup lang="ts">
import { useMaterialStore } from '@/stores/material'
import { useStockStore } from '@/stores/stock'
import { useStockDetailStore } from '@/stores/stockDetail'
import type { StockDetail } from '@/types/StockDetail'
import { onMounted, ref, computed } from 'vue'

onMounted(async () => {
  await stockStore.getStocks()
  await materialStore.getMaterials()
  await stockDetailStore.getStockDetailsByStockId(
    stockStore.stocks[stockStore.stocks.length - 1].id
  )
  laststockDetails.value = stockDetailStore.stockDetails
})

const Matsheaders = [
  {
    title: 'รหัสของรายละเอียดของสต็อก',
    key: 'id',
    value: 'id',
    width: '300px'
  },
  {
    title: 'ชื่อวัตถุดิบ',
    key: 'material id',
    value: 'material id',
    width: '300px'
  },
  {
    title: 'ส่วนต่างของปริมาณกับขีดต่ำสุด',
    key: 'balance',
    value: 'balance',
    width: '300px'
  },
  {
    title: 'หน่วย',
    key: 'type',
    value: 'type',
    width: '100px'
  }
]

const stockStore = useStockStore()
const stockDetailStore = useStockDetailStore()
const materialStore = useMaterialStore()

const laststockDetails = ref<StockDetail[]>([])

function refresh() {
  console.log('stockDetailStore.stockDetails', stockDetailStore.stockDetails)
}
function findTypeMat(materialId: number) {
  for (const sd of stockDetailStore.stockDetails) {
    const findMat = materialStore.materials.find((mat) => mat.id === materialId)

    if (findMat) {
      return findMat.type
    } else {
      return 'Unit'
    }
  }
}
const balanceColor = computed(() => {
  return (balance: number) => {
    if (balance === 5) {
      return 'orange'
    } else if (balance > 0) {
      return 'green'
    } else {
      return 'red'
    }
  }
})
</script>

<template>
  <v-sheet>
    <v-data-table
      :items="laststockDetails"
      :headers="Matsheaders"
      class="elevation-1 custom-table"
      fixed-header
      height="350px"
    >
      <template v-slot:item="props">
        <tr>
          <td>{{ props.item.id }}</td>
          <td>{{ stockDetailStore.getMaterialName(props.item.materialId) }}</td>
          <!-- Apply style attribute dynamically to change text color based on balance -->
          <td>
            <v-chip :color="balanceColor(props.item.balance)">{{ props.item.balance }}</v-chip>
          </td>
          <td>{{ findTypeMat(props.item.materialId) }}</td>
        </tr>
      </template>
    </v-data-table>
  </v-sheet>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}

.custom-header {
  background-color: #ffcb5e;
}
</style>
